'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Decompiler
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Timer
Import BRL.Retro
Import MaxGUI.Win32MaxGUIEx

' modules which may be required:
 Import brl.PNGLoader
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader
Include "GBAGFX.bmx"
SetGraphicsDriver D3D7Max2DDriver() 
Print "Doom II GBA - Modding Tools - http://kippykip.com"
Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function

'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf

Function ConvertFile(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("bin\" + TMP_FileName:String + ".txt") 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("COUNT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("COUNT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Count:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "FLAT") 
		TMP_SourceFileX2:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.PNG"
		TMP_DestFileX3:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.PNG"
		TMP_DestFileX4:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.PNG"
		TMP_DestFileX5:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.PNG"
		TMP_DestFileX6:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.PNG"
		TMP_DestFileX7:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.PNG"
		TMP_DestFileX8:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.PNG"
	
		If(FileType(TMP_SourceFileX1:String) = 1) 
			TMP_Image:TImage = LoadImage(TMP_SourceFileX2:String, DYNAMICIMAGE) 
			TMP_X2Width:Int = ImageWidth(TMP_Image:TImage) 
			TMP_X2Height:Int = ImageHeight(TMP_Image:TImage) 
			If(TMP_X2Width:Int < 1) 
				TMP_X2Width:Int = 1
			EndIf
			If(TMP_X2Height:Int < 1) 
				TMP_X2Height:Int = 1
			EndIf
			TMP_X3Width:Int = TMP_X2Width:Int / 2
			TMP_X3Height:Int = TMP_X2Height:Int / 2
			If(TMP_X3Width:Int < 1) 
				TMP_X3Width:Int = 1
			EndIf
			If(TMP_X3Height:Int < 1) 
				TMP_X3Height:Int = 1
			EndIf
			TMP_X4Width:Int = TMP_X3Width:Int / 2
			TMP_X4Height:Int = TMP_X3Height:Int / 2
			If(TMP_X4Width:Int < 1) 
				TMP_X4Width:Int = 1
			EndIf
			If(TMP_X4Height:Int < 1) 
				TMP_X4Height:Int = 1
			EndIf
			TMP_X5Width:Int = TMP_X4Width:Int / 2
			TMP_X5Height:Int = TMP_X4Height:Int / 2
			If(TMP_X5Width:Int < 1) 
				TMP_X5Width:Int = 1
			EndIf
			If(TMP_X5Height:Int < 1) 
				TMP_X5Height:Int = 1
			EndIf
			TMP_X6Width:Int = TMP_X5Width:Int / 2
			TMP_X6Height:Int = TMP_X5Height:Int / 2
			If(TMP_X6Width:Int < 1) 
				TMP_X6Width:Int = 1
			EndIf
			If(TMP_X6Height:Int < 1) 
				TMP_X6Height:Int = 1
			EndIf
			TMP_X7Width:Int = TMP_X6Width:Int / 2
			TMP_X7Height:Int = TMP_X6Height:Int / 2
			If(TMP_X7Width:Int < 1) 
				TMP_X7Width:Int = 1
			EndIf
			If(TMP_X7Height:Int < 1) 
				TMP_X7Height:Int = 1
			EndIf
			TMP_X8Width:Int = TMP_X7Width:Int / 2
			TMP_X8Height:Int = TMP_X7Height:Int / 2
			If(TMP_X8Width:Int < 1) 
				TMP_X8Width:Int = 1
			EndIf
			If(TMP_X8Height:Int < 1) 
				TMP_X8Height:Int = 1
			EndIf
			Print("Downscaling: " + TMP_SourceFileX1:String) 					
			TMP_Pixmap:TPixmap = LockImage(TMP_Image:TImage) 
			TMP_PixmapX3:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X3Width, TMP_X3Height) 
			SavePixmapPNG(TMP_PixmapX3:TPixmap, TMP_DestFileX3:String) 
			Print("Exported: " + TMP_DestFileX3:String) 
			TMP_PixmapX4:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X4Width, TMP_X4Height) 
			SavePixmapPNG(TMP_PixmapX4:TPixmap, TMP_DestFileX4:String) 
			Print("Exported: " + TMP_DestFileX4:String) 
			TMP_PixmapX5:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X5Width, TMP_X5Height) 
			SavePixmapPNG(TMP_PixmapX5:TPixmap, TMP_DestFileX5:String) 
			Print("Exported: " + TMP_DestFileX5:String) 
			TMP_PixmapX6:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X6Width, TMP_X6Height) 
			SavePixmapPNG(TMP_PixmapX6:TPixmap, TMP_DestFileX6:String) 
			Print("Exported: " + TMP_DestFileX6:String) 
			TMP_PixmapX7:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X7Width, TMP_X7Height) 
			SavePixmapPNG(TMP_PixmapX7:TPixmap, TMP_DestFileX7:String) 
			Print("Exported: " + TMP_DestFileX7:String) 
			TMP_PixmapX8:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X8Width, TMP_X8Height) 
			SavePixmapPNG(TMP_PixmapX8:TPixmap, TMP_DestFileX8:String) 
			Print("Exported: " + TMP_DestFileX8:String) 
		Else
			Print("Missing: '" + TMP_SourceFileX1:String + "'. Ignoring.") 
		EndIf
	EndIf
	
	If(TMP_Type:String = "SPRITE" Or TMP_Type:String = "TEXTURE") 
		'TMP_SourceFileH:TBank = LoadBank("decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		TMP_SourceFileX1:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.PNG"
		TMP_DestFileX2:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.PNG"
		TMP_DestFileX3:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.PNG"
		TMP_DestFileX4:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.PNG"
		TMP_DestFileX5:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.PNG"
		TMP_DestFileX6:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.PNG"
		TMP_DestFileX7:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.PNG"
		TMP_DestFileX8:String = "decompile\PNG\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.PNG"
	
		
		If(FileType(TMP_SourceFileX1:String) = 1) 
			TMP_Image:TImage = LoadImage(TMP_SourceFileX1:String, DYNAMICIMAGE) 
			TMP_X1Width:Int = ImageWidth(TMP_Image:TImage) 
			TMP_X1Height:Int = ImageHeight(TMP_Image:TImage) 
			If(TMP_X1Width:Int < 1) 
				TMP_X1Width:Int = 1
			EndIf
			If(TMP_X1Height:Int < 1) 
				TMP_X1Height:Int = 1
			EndIf
			TMP_X2Width:Int = TMP_X1Width:Int / 2
			TMP_X2Height:Int = TMP_X1Height:Int / 2
			If(TMP_X2Width:Int < 1) 
				TMP_X2Width:Int = 1
			EndIf
			If(TMP_X2Height:Int < 1) 
				TMP_X2Height:Int = 1
			EndIf
			TMP_X3Width:Int = TMP_X2Width:Int / 2
			TMP_X3Height:Int = TMP_X2Height:Int / 2
			If(TMP_X3Width:Int < 1) 
				TMP_X3Width:Int = 1
			EndIf
			If(TMP_X3Height:Int < 1) 
				TMP_X3Height:Int = 1
			EndIf
			TMP_X4Width:Int = TMP_X3Width:Int / 2
			TMP_X4Height:Int = TMP_X3Height:Int / 2
			If(TMP_X4Width:Int < 1) 
				TMP_X4Width:Int = 1
			EndIf
			If(TMP_X4Height:Int < 1) 
				TMP_X4Height:Int = 1
			EndIf
			TMP_X5Width:Int = TMP_X4Width:Int / 2
			TMP_X5Height:Int = TMP_X4Height:Int / 2
			If(TMP_X5Width:Int < 1) 
				TMP_X5Width:Int = 1
			EndIf
			If(TMP_X5Height:Int < 1) 
				TMP_X5Height:Int = 1
			EndIf
			TMP_X6Width:Int = TMP_X5Width:Int / 2
			TMP_X6Height:Int = TMP_X5Height:Int / 2
			If(TMP_X6Width:Int < 1) 
				TMP_X6Width:Int = 1
			EndIf
			If(TMP_X6Height:Int < 1) 
				TMP_X6Height:Int = 1
			EndIf
			TMP_X7Width:Int = TMP_X6Width:Int / 2
			TMP_X7Height:Int = TMP_X6Height:Int / 2
			If(TMP_X7Width:Int < 1) 
				TMP_X7Width:Int = 1
			EndIf
			If(TMP_X7Height:Int < 1) 
				TMP_X7Height:Int = 1
			EndIf
			TMP_X8Width:Int = TMP_X7Width:Int / 2
			TMP_X8Height:Int = TMP_X7Height:Int / 2
			If(TMP_X8Width:Int < 1) 
				TMP_X8Width:Int = 1
			EndIf
			If(TMP_X8Height:Int < 1) 
				TMP_X8Height:Int = 1
			EndIf
			Print("Downscaling: " + TMP_SourceFileX1:String) 					
			TMP_Pixmap:TPixmap = LockImage(TMP_Image:TImage) 
			TMP_PixmapX2:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X2Width, TMP_X2Height) 
			SavePixmapPNG(TMP_PixmapX2:TPixmap, TMP_DestFileX2:String) 
			Print("Exported: " + TMP_DestFileX2:String) 
			TMP_PixmapX3:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X3Width, TMP_X3Height) 
			SavePixmapPNG(TMP_PixmapX3:TPixmap, TMP_DestFileX3:String) 
			Print("Exported: " + TMP_DestFileX3:String) 
			TMP_PixmapX4:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X4Width, TMP_X4Height) 
			SavePixmapPNG(TMP_PixmapX4:TPixmap, TMP_DestFileX4:String) 
			Print("Exported: " + TMP_DestFileX4:String) 
			TMP_PixmapX5:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X5Width, TMP_X5Height) 
			SavePixmapPNG(TMP_PixmapX5:TPixmap, TMP_DestFileX5:String) 
			Print("Exported: " + TMP_DestFileX5:String) 
			TMP_PixmapX6:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X6Width, TMP_X6Height) 
			SavePixmapPNG(TMP_PixmapX6:TPixmap, TMP_DestFileX6:String) 
			Print("Exported: " + TMP_DestFileX6:String) 
			TMP_PixmapX7:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X7Width, TMP_X7Height) 
			SavePixmapPNG(TMP_PixmapX7:TPixmap, TMP_DestFileX7:String) 
			Print("Exported: " + TMP_DestFileX7:String) 
			TMP_PixmapX8:TPixmap = ResizePixmap(TMP_Pixmap:TPixmap, TMP_X8Width, TMP_X8Height) 
			SavePixmapPNG(TMP_PixmapX8:TPixmap, TMP_DestFileX8:String) 
			Print("Exported: " + TMP_DestFileX8:String) 
		Else
			Print("Missing: '" + TMP_SourceFileX1:String + "'. Ignoring.") 
		EndIf
	EndIf

EndFunction

Repeat
	TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
	If(TMP_CurrentFile:String = "") 
		Exit
	ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
		If(TMP_CurrentFile:String.EndsWith(".TXT")) 
			Print "Checking: " + TMP_CurrentFile:String
			ConvertFile(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
		EndIf
	EndIf
Forever
Print "Successfully downscaled all X1 files."