'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: X1-Downscaler
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

'Framework brl.D3D7Max2D
'Import brl.StandardIO
'Import brl.Retro
'Import BRL.PNGLoader

'Import MaxGUI.Win32MaxGUIEx

' modules which may be required:
' Import brl.PNGLoader
' Import BRL.BMPLoader
' Import BRL.TGALoader
' Import BRL.JPGLoader
Include "GBAGFX.bmx"
SetGraphicsDriver D3D7Max2DDriver() 
Print "Doom II GBA - Modding Tools - http://kippykip.com"
Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function

'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf

Function ConvertFile(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("BIN\" + TMP_FileName:String + ".TXT") 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("COUNT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("COUNT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Count:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "FLAT") 
		TMP_SourceFileH:TBank = LoadBank("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		TMP_SourceFileX2:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		TMP_DestFileX3:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		TMP_DestFileX4:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		TMP_DestFileX5:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		TMP_DestFileX6:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		TMP_DestFileX7:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		TMP_DestFileX8:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
		
		If(FileType(TMP_SourceFileX2:String) = 1) 
			Print("Downscaling: " + TMP_SourceFileX2:String) 
			TMP_X1Width:Int = PeekInt(TMP_SourceFileH:TBank, 8) 
			TMP_X1Height:Int = PeekInt(TMP_SourceFileH:TBank, 4) 
			If(TMP_X1Width:Int < 1) 
				TMP_X1Width:Int = 1
			EndIf
			If(TMP_X1Height:Int < 1) 
				TMP_X1Height:Int = 1
			EndIf
			TMP_X2Width:Int = TMP_X1Width:Int / 2
			TMP_X2Height:Int = TMP_X1Height:Int / 2
			If(TMP_X2Width:Int < 1) 
				TMP_X2Width:Int = 1
			EndIf
			If(TMP_X2Height:Int < 1) 
				TMP_X2Height:Int = 1
			EndIf
			TMP_X3Width:Int = TMP_X2Width:Int / 2
			TMP_X3Height:Int = TMP_X2Height:Int / 2
			If(TMP_X3Width:Int < 1) 
				TMP_X3Width:Int = 1
			EndIf
			If(TMP_X3Height:Int < 1) 
				TMP_X3Height:Int = 1
			EndIf
			TMP_X4Width:Int = TMP_X3Width:Int / 2
			TMP_X4Height:Int = TMP_X3Height:Int / 2
			If(TMP_X4Width:Int < 1) 
				TMP_X4Width:Int = 1
			EndIf
			If(TMP_X4Height:Int < 1) 
				TMP_X4Height:Int = 1
			EndIf
			TMP_X5Width:Int = TMP_X4Width:Int / 2
			TMP_X5Height:Int = TMP_X4Height:Int / 2
			If(TMP_X5Width:Int < 1) 
				TMP_X5Width:Int = 1
			EndIf
			If(TMP_X5Height:Int < 1) 
				TMP_X5Height:Int = 1
			EndIf
			TMP_X6Width:Int = TMP_X5Width:Int / 2
			TMP_X6Height:Int = TMP_X5Height:Int / 2
			If(TMP_X6Width:Int < 1) 
				TMP_X6Width:Int = 1
			EndIf
			If(TMP_X6Height:Int < 1) 
				TMP_X6Height:Int = 1
			EndIf
			TMP_X7Width:Int = TMP_X6Width:Int / 2
			TMP_X7Height:Int = TMP_X6Height:Int / 2
			If(TMP_X7Width:Int < 1) 
				TMP_X7Width:Int = 1
			EndIf
			If(TMP_X7Height:Int < 1) 
				TMP_X7Height:Int = 1
			EndIf
			TMP_X8Width:Int = TMP_X7Width:Int / 2
			TMP_X8Height:Int = TMP_X7Height:Int / 2
			If(TMP_X8Width:Int < 1) 
				TMP_X8Width:Int = 1
			EndIf
			If(TMP_X8Height:Int < 1) 
				TMP_X8Height:Int = 1
			EndIf
			
			TMP_X2Data:TBank = LoadBank(TMP_SourceFileX2:String) 
			TMP_X3Data:TBank = CreateBank(TMP_X3Width:Int * TMP_X3Height:Int) 
			TMP_X4Data:TBank = CreateBank(TMP_X4Width:Int * TMP_X4Height:Int) 	
			TMP_X5Data:TBank = CreateBank(TMP_X5Width:Int * TMP_X5Height:Int) 
			TMP_X6Data:TBank = CreateBank(TMP_X6Width:Int * TMP_X6Height:Int) 
			TMP_X7Data:TBank = CreateBank(TMP_X7Width:Int * TMP_X7Height:Int) 
			TMP_X8Data:TBank = CreateBank(TMP_X8Width:Int * TMP_X8Height:Int) 
			
			'X3 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X3Width:Int * TMP_X3Height:Int - 1
				PokeByte(TMP_X3Data:TBank, BankSize(TMP_X3Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 2) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X3Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 1) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X3Data:TBank, TMP_DestFileX3:String) 
			Print("Exported: " + TMP_DestFileX3:String) 
			TMP_X3Data:TBank = Null
			
			'X4 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X4Width:Int * TMP_X4Height:Int - 1
				PokeByte(TMP_X4Data:TBank, BankSize(TMP_X4Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 4) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X4Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 3) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X4Data:TBank, TMP_DestFileX4:String) 
			Print("Exported: " + TMP_DestFileX4:String) 
			TMP_X4Data:TBank = Null
			
			'X5 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X5Width:Int * TMP_X5Height:Int - 1
				PokeByte(TMP_X5Data:TBank, BankSize(TMP_X5Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 8) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X5Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 7) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X5Data:TBank, TMP_DestFileX5:String) 
			Print("Exported: " + TMP_DestFileX5:String) 
			TMP_X5Data:TBank = Null
			
			'X6 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X6Width:Int * TMP_X6Height:Int - 1
				PokeByte(TMP_X6Data:TBank, BankSize(TMP_X6Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 16) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X6Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 15) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X6Data:TBank, TMP_DestFileX6:String) 
			Print("Exported: " + TMP_DestFileX6:String) 
			TMP_X6Data:TBank = Null
			
			'X7 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X7Width:Int * TMP_X7Height:Int - 1
				PokeByte(TMP_X7Data:TBank, BankSize(TMP_X7Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 32) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X7Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 31) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X7Data:TBank, TMP_DestFileX7:String) 
			Print("Exported: " + TMP_DestFileX7:String) 
			TMP_X7Data:TBank = Null
			
			'X8 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X8Width:Int * TMP_X8Height:Int - 1
				PokeByte(TMP_X8Data:TBank, BankSize(TMP_X8Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - (TMP_CurrentByte * 64) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X8Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X2Height:Int * 63) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X8Data:TBank, TMP_DestFileX8:String) 
			Print("Exported: " + TMP_DestFileX8:String) 
			TMP_X8Data:TBank = Null
		Else
			Print("Missing: '" + TMP_SourceFileX2:String + "'. Ignoring.") 
		EndIf
	EndIf
	
	If(TMP_Type:String = "SPRITE" Or TMP_Type:String = "TEXTURE") 
		TMP_SourceFileHFN:String = "decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		If(FileType("recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H")) 
			TMP_SourceFileHFN:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		EndIf
		TMP_SourceFileH:TBank = LoadBank(TMP_SourceFileHFN) 
		TMP_SourceFileX1:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"
		TMP_DestFileX2:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		TMP_DestFileX3:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		TMP_DestFileX4:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		TMP_DestFileX5:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		TMP_DestFileX6:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		TMP_DestFileX7:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		TMP_DestFileX8:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
		TMP_X1Width:Int = PeekInt(TMP_SourceFileH:TBank, 8) 
		TMP_X1Height:Int = PeekInt(TMP_SourceFileH:TBank, 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		
		If(FileType(TMP_SourceFileX1:String) = 1) 
			TMP_X1Data:TBank = LoadBank(TMP_SourceFileX1:String) 
			TMP_X2Data:TBank = CreateBank(TMP_X2Width:Int * TMP_X2Height:Int) 
			TMP_X3Data:TBank = CreateBank(TMP_X3Width:Int * TMP_X3Height:Int) 
			TMP_X4Data:TBank = CreateBank(TMP_X4Width:Int * TMP_X4Height:Int) 	
			TMP_X5Data:TBank = CreateBank(TMP_X5Width:Int * TMP_X5Height:Int) 	
			TMP_X6Data:TBank = CreateBank(TMP_X6Width:Int * TMP_X6Height:Int) 
			TMP_X7Data:TBank = CreateBank(TMP_X7Width:Int * TMP_X7Height:Int) 
			TMP_X8Data:TBank = CreateBank(TMP_X8Width:Int * TMP_X8Height:Int) 
			Print("Downscaling: " + TMP_SourceFileX1:String) 
						
			'X2 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X2Width:Int * TMP_X2Height:Int - 1
				PokeByte(TMP_X2Data:TBank, BankSize(TMP_X2Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 2) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X2Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + TMP_X1Height:Int
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X2Data:TBank, TMP_DestFileX2:String) 
			Print("Exported: " + TMP_DestFileX2:String) 
			TMP_X2Data:TBank = Null
			
			'X3 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X3Width:Int * TMP_X3Height:Int - 1
				PokeByte(TMP_X3Data:TBank, BankSize(TMP_X3Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 4) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X3Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 3) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X3Data:TBank, TMP_DestFileX3:String) 
			Print("Exported: " + TMP_DestFileX3:String) 
			TMP_X3Data:TBank = Null
			
			'X4 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X4Width:Int * TMP_X4Height:Int - 1
				PokeByte(TMP_X4Data:TBank, BankSize(TMP_X4Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 8) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X4Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 7) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X4Data:TBank, TMP_DestFileX4:String) 
			Print("Exported: " + TMP_DestFileX4:String) 
			TMP_X4Data:TBank = Null
			
			'X5 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X5Width:Int * TMP_X5Height:Int - 1
				PokeByte(TMP_X5Data:TBank, BankSize(TMP_X5Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 16) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X5Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 15) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X5Data:TBank, TMP_DestFileX5:String) 
			Print("Exported: " + TMP_DestFileX5:String) 
			TMP_X5Data:TBank = Null
			
			'X6 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X6Width:Int * TMP_X6Height:Int - 1
				PokeByte(TMP_X6Data:TBank, BankSize(TMP_X6Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 32) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X6Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 31) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X6Data:TBank, TMP_DestFileX6:String) 
			Print("Exported: " + TMP_DestFileX6:String) 
			TMP_X6Data:TBank = Null
			
			'X7 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X7Width:Int * TMP_X7Height:Int - 1
				PokeByte(TMP_X7Data:TBank, BankSize(TMP_X7Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 64) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X7Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 63) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X7Data:TBank, TMP_DestFileX7:String) 
			Print("Exported: " + TMP_DestFileX7:String) 
			TMP_X7Data:TBank = Null
			
			'X8 Downscale
			TMP_YCounter:Int = 0
			TMP_YSkipper:Int = 0
			For TMP_CurrentByte = 0 To TMP_X8Width:Int * TMP_X8Height:Int - 1
				PokeByte(TMP_X8Data:TBank, BankSize(TMP_X8Data:TBank) - 1 - TMP_CurrentByte, PeekByte(TMP_X1Data:TBank, BankSize(TMP_X1Data:TBank) - 1 - (TMP_CurrentByte * 128) - TMP_YSkipper:Int)) 
				TMP_YCounter:Int = TMP_YCounter:Int + 1
				If(TMP_YCounter:Int >= TMP_X8Height:Int) 
					TMP_YSkipper:Int = TMP_YSkipper:Int + (TMP_X1Height:Int * 127) 
					TMP_YCounter:Int = 0
				EndIf
			Next
			SaveBank(TMP_X8Data:TBank, TMP_DestFileX8:String) 
			Print("Exported: " + TMP_DestFileX8:String) 
			TMP_X8Data:TBank = Null
			
			rem For TMP_CurrentByteX = 1 To TMP_X2Width:Int
				For TMP_CurrentByteY = 1 To TMP_X2Height:Int
					If(TMP_X2Width:Int * TMP_X2Height:Int = 1) 
						PokeByte(TMP_X2Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int / 2)) 
					Else
						'Print (TMP_CurrentByteY * 2) - 1 + (((TMP_CurrentByteX * 2) - 1) * TMP_X1Height:Int)
						'Print BankSize(TMP_X1Data:TBank
						PokeByte(TMP_X2Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X2Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 2) - 1 + (((TMP_CurrentByteX * 2) - 1) * TMP_X1Height:Int)))
						PokeByte(TMP_X2Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X2Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 2) - 1 + (((TMP_CurrentByteX * 2) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X2Data:TBank, TMP_DestFileX2:String) 
			Print("Exported: " + TMP_DestFileX2:String) 
			TMP_X2Data:TBank = Null
			
			'X3 Downscale
			For TMP_CurrentByteX = 1 To TMP_X3Width:Int
				For TMP_CurrentByteY = 1 To TMP_X3Height:Int
					If(TMP_X3Width:Int * TMP_X3Height:Int = 1) 
						PokeByte(TMP_X3Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X3Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X3Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 4) - 1 + (((TMP_CurrentByteX * 4) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X3Data:TBank, TMP_DestFileX3:String) 
			Print("Exported: " + TMP_DestFileX3:String) 
			TMP_X3Data:TBank = Null
			
			'X4 Downscale
			For TMP_CurrentByteX = 1 To TMP_X4Width:Int
				For TMP_CurrentByteY = 1 To TMP_X4Height:Int
					If(TMP_X4Width:Int * TMP_X4Height:Int = 1) 
						PokeByte(TMP_X4Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X4Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X4Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 8) - 1 + (((TMP_CurrentByteX * 8) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X4Data:TBank, TMP_DestFileX4:String) 
			Print("Exported: " + TMP_DestFileX4:String) 
			TMP_X4Data:TBank = Null
			
			'X5 Downscale
			For TMP_CurrentByteX = 1 To TMP_X5Width:Int
				For TMP_CurrentByteY = 1 To TMP_X5Height:Int
					If(TMP_X5Width:Int * TMP_X5Height:Int = 1) 
						PokeByte(TMP_X5Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X5Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X5Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 16) - 1 + (((TMP_CurrentByteX * 16) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X5Data:TBank, TMP_DestFileX5:String) 
			Print("Exported: " + TMP_DestFileX5:String) 
			TMP_X5Data:TBank = Null
			
			'X6 Downscale
			For TMP_CurrentByteX = 1 To TMP_X6Width:Int
				For TMP_CurrentByteY = 1 To TMP_X6Height:Int
					If(TMP_X6Width:Int * TMP_X6Height:Int = 1) 
						PokeByte(TMP_X6Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X6Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X6Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 32) - 1 + (((TMP_CurrentByteX * 32) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X6Data:TBank, TMP_DestFileX6:String) 
			Print("Exported: " + TMP_DestFileX6:String) 
			TMP_X6Data:TBank = Null
			
			'X7 Downscale
			For TMP_CurrentByteX = 1 To TMP_X7Width:Int
				For TMP_CurrentByteY = 1 To TMP_X7Height:Int
					If(TMP_X7Width:Int * TMP_X7Height:Int = 1) 
						PokeByte(TMP_X7Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X7Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X7Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 64) - 1 + (((TMP_CurrentByteX * 64) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X7Data:TBank, TMP_DestFileX7:String) 
			Print("Exported: " + TMP_DestFileX7:String) 
			TMP_X7Data:TBank = Null
			
			'X8 Downscale
			For TMP_CurrentByteX = 1 To TMP_X8Width:Int
				For TMP_CurrentByteY = 1 To TMP_X8Height:Int
					If(TMP_X8Width:Int * TMP_X8Height:Int = 1) 
						PokeByte(TMP_X8Data:TBank, 0, PeekByte(TMP_X1Data:TBank, TMP_X1Width:Int * TMP_X1Height:Int - 1)) 
					Else
						PokeByte(TMP_X8Data:TBank, TMP_CurrentByteY - 1 + ((TMP_CurrentByteX - 1) * TMP_X8Height:Int), PeekByte(TMP_X1Data:TBank, (TMP_CurrentByteY * 128) - 1 + (((TMP_CurrentByteX * 128) - 1) * TMP_X1Height:Int))) 
					EndIf
				Next
			Next
			SaveBank(TMP_X8Data:TBank, TMP_DestFileX8:String) 
			TMP_X8Data:TBank = Null
			Print("Exported: " + TMP_DestFileX8:String) 
			endrem
		Else
			Print("Missing: '" + TMP_SourceFileX1:String + "'. Ignoring.") 
		EndIf
	EndIf

EndFunction

Repeat
	TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
	If(TMP_CurrentFile:String = "") 
		Exit
	ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
		If(TMP_CurrentFile:String.EndsWith(".TXT")) 
			Print "Checking: " + TMP_CurrentFile:String
			ConvertFile(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
			'Sleep(2) 
			'waitKey
		EndIf
	EndIf
Forever

Print "Successfully downscaled all X1 files."