'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Palette Viewer
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Bank
Import BRL.System
Import BRL.Timer


SetGraphicsDriver D3D7Max2DDriver() 


Global TMP_BANK:TBank
If(AppArgs.length > 1) 
	TMP_BANK:TBank = LoadBank(AppArgs[1] ) 
	AppTitle:String = AppArgs[1] 
Else
	AppTitle:String = "Palette Viewer: ERROR"
	Notify("Missing command line! Nothing to open!", True) 
	End
EndIf

Graphics 640, 640 + 12, 0, 60
'SetBlend(ALPHABLEND) 
Global DestFile = WriteFile("convert.pal")
Cls
Global Timer = CreateTimer(30) 
For z = 0 To 255
	SetColor(PeekByte(TMP_BANK:TBank, z + PaletteIndex), PeekByte(TMP_BANK:TBank, z + PaletteIndex + 1), PeekByte(TMP_BANK:TBank, z + PaletteIndex + 2)) 
	WriteByte(DestFile, PeekByte(TMP_BANK:TBank, z + PaletteIndex))
	WriteByte(DestFile, PeekByte(TMP_BANK:TBank, z + PaletteIndex + 1))
	WriteByte(DestFile, PeekByte(TMP_BANK:TBank, z + PaletteIndex + 2))
	WriteByte(DestFile, 0)
	DrawRect(x * 40, y * 40, 40, 40) 
	x = x + 1
	'go to a new line after 16 colours
	If(x >= 16) 
		x = 0
		y = y + 1
	EndIf
	PaletteIndex = PaletteIndex + 2
Next
CloseFile(DestFile)

While Not(AppTerminate()) 
	WaitTimer(Timer) 
	SetColor(0, 0, 0) 
	DrawRect(0, GraphicsHeight() - 12, GraphicsWidth(), 12) 
	SetColor(255, 255, 255) 
	If(MouseY() < 640) 
		TMP_MouseIndex:Int = (MouseX() / 40) + (MouseY() / 40 * 16) 
		
		DrawText "Index: " + TMP_MouseIndex:Int + " RGB: " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3) + ", " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3 + 1) + ", " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3 + 2), 0, GraphicsHeight() - 12
		
	EndIf
	Flip
Wend