'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Palette Viewer
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Bank
Import BRL.System
Import BRL.Timer
Import BRL.Retro
Import brl.PNGLoader
 
SetGraphicsDriver D3D7Max2DDriver() 
Print "Doom II GBA - Modding Tools - http://kippykip.com"
Include "GBAGFX.bmx"
Global TMP_BANK:TBank
Global exportedPNG = False
If(AppArgs.length > 1) 
	TMP_BANK:TBank = LoadBank(AppArgs[1] ) 
	AppTitle:String = AppArgs[1] 
Else
	AppTitle:String = "Palette Viewer: ERROR"
	Notify("Missing command line! Nothing to open!", True) 
	End
EndIf

Global SplitFN:String[] = AppArgs[1].Split("\") 
Global CurrentFolder:String
For FNx = 0 To SplitFN.Length - 2
	CurrentFolder:String = CurrentFolder:String + SplitFN[FNx] + "\"
Next
Global LoadedFN:String = Upper:String(SplitFN[SplitFN.Length - 1] ) 
Global SplitFN2:String[] = LoadedFN:String.Split(".") 

Graphics 640, 640 + 14 + 14, 0, 60
'SetBlend(ALPHABLEND) 
Cls
Global Timer = CreateTimer(30) 
For z = 0 To 255
	SetColor(PeekByte(TMP_BANK:TBank, z + PaletteIndex), PeekByte(TMP_BANK:TBank, z + PaletteIndex + 1), PeekByte(TMP_BANK:TBank, z + PaletteIndex + 2)) 
	DrawRect(x * 40, y * 40, 40, 40) 
	x = x + 1
	'go to a new line after 16 colours
	If(x >= 16) 
		x = 0
		y = y + 1
	EndIf
	PaletteIndex = PaletteIndex + 2
Next

While Not(AppTerminate()) 
	WaitTimer(Timer) 
	SetColor(0, 0, 0) 
	DrawRect(0, GraphicsHeight() - 28, GraphicsWidth(), 28) 
	SetColor(255, 255, 255) 
	If(MouseY() < 640) 
		TMP_MouseIndex:Int = (MouseX() / 40) + (MouseY() / 40 * 16) 
		
		DrawText "Index: " + TMP_MouseIndex:Int + " Hex Index: " + right$(Hex:String(TMP_MouseIndex:Int), 2) + " RGB: " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3) + ", " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3 + 1) + ", " + PeekByte(TMP_BANK:TBank, TMP_MouseIndex:Int * 3 + 2), 0, GraphicsHeight() - 28
		
	EndIf
	If(exportedPNG) 
		DrawText("Exported to: " + "DECOMPILE\PNG\PALETTE\" + Left:String(LoadedFN:String, LoadedFN:String.Length - 4) + ".PNG", 2, GraphicsHeight() - 14) 
	Else
		DrawText("Press Spacebar to export to PNG", 2, GraphicsHeight() - 14) 
	EndIf
	If(KeyDown(KEY_SPACE) And exportedPNG = False) 
	'	GFX.KConvertTexture(AppArgs[1] , Width, Height, True, True, "DECOMPILE\PNG\" + SplitFN[SplitFN.Length - 2] + "\" + SplitFN2[0] + "." + SplitFN2[1] + ".PNG") 
		GFX.KConvertPalette(AppArgs[1] , True, "DECOMPILE\PNG\PALETTE\" + Left:String(LoadedFN:String, LoadedFN:String.Length - 4) + ".PNG") 
		exportedPNG = True
	EndIf
	Flip
WEnd