'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Decompiler
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Bank
Import BRL.System
Import BRL.Timer
Import BRL.Retro
Import brl.PNGLoader
Include "GBAGFX.bmx"
Global Rom = LoadBank("DoomII.gba") 
'Global Rom = LoadBank("DoomII_Recomp.gba") 
Global ImageDataOffset:Int = 3316928 'Always gotta add this when decompiling sprites/textures/flats for some reason
Print "Doom II GBA - Modding Tools - http://kippykip.com"

Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function
Function printf(TMP_TXT:String = "") 
	'If you really want to re-enable the detailed stuff ;)
	'Print TMP_TXT:String
End Function
Function DecompileFile(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("bin\" + TMP_FileName:String + ".txt") 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("COUNT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("COUNT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Count:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "PALETTE") 
		printf("Decompiling '" + TMP_Count:Int + "' palettes at offset: " + TMP_Offset:Int) 
		'loop how many palettes etc
		For TMP_CurrentPalette = 1 To TMP_Count
			TMP_File:TStream = WriteFile("decompile\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentPalette + ".D2P") 
			'There are 256 colours in each palette
			For TMP_CurrentByte = 1 To 256 * 3 'RGB is 3
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 3 * 256))) 
				'printf (TMP_CurrentPalette - 1) * 256
			Next
			printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + "." + TMP_CurrentPalette + ".D2P"
			CloseFile(TMP_File:TStream) 
		Next
	EndIf
	If(TMP_Type:String = "555PALETTE") 
		printf("Decompiling '" + TMP_Count:Int + "' type RGB555 palettes at offset: " + TMP_Offset:Int) 
		'loop how many palettes etc
		For TMP_CurrentPalette = 1 To TMP_Count
			TMP_WriteFN:String = "decompile\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentPalette + ".D2P"
			If(TMP_Count = 1) 
				TMP_WriteFN:String = "decompile\PALETTE\" + TMP_FileName:String + ".D2P"
			EndIf
			TMP_File:TStream = WriteFile(TMP_WriteFN:String) 
			'There are 256 colours in each palette
			For TMP_CurrentByte = 1 To 256
				'Convert it to the RGB555 2 byte format
				TMP_555RGB:Short = PeekShort(Rom, (TMP_CurrentByte - 1) * 2 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 2 * 256)) 
				WriteByte(TMP_File:TStream, GFX.Convert555to8888_Red:Int(TMP_555RGB)) 
				WriteByte(TMP_File:TStream, GFX.Convert555to8888_Green:Int(TMP_555RGB)) 
				WriteByte(TMP_File:TStream, GFX.Convert555to8888_Blue:Int(TMP_555RGB)) 
			Next
			printf "Done writing: " + TMP_WriteFN:String
			CloseFile(TMP_File:TStream) 
		Next
	EndIf
	If(TMP_Type:String = "BLANKMEM") 
		printf("Extracting '" + TMP_Count:Int + "' bytes at offset: " + TMP_Offset:Int) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_FileName:String + ".D2M") 
		For TMP_CurrentByte = 1 To TMP_Count
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_FileName:String + ".D2M"
		CloseFile(TMP_File:TStream) 
	EndIf
	If(TMP_Type:String = "SOUND") 
		printf("Extracting '" + TMP_Count:Int + "' bytes at offset: " + TMP_Offset:Int) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".RAW") 
		For TMP_CurrentByte = 1 To TMP_Count
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".RAW"
		CloseFile(TMP_File:TStream) 
	EndIf	
	If(TMP_Type:String = "IMAGE" Or TMP_Type:String = "TIMAGE") 
		printf("Decompiling image at offset: " + TMP_Offset:Int + ", " + TMP_Width:Int * TMP_Height:Int + " bytes in size.") 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".D2I") 
		For TMP_CurrentByte = 1 To TMP_Width:Int * TMP_Height:Int
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".D2I"
	EndIf
	If(TMP_Type:String = "FLAT") 
		'Flat header
		printf("Decompiling flat '" + TMP_FileName:String + "' header at offset: " + TMP_Offset:Int) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		For TMP_CurrentByte = 1 To 64 * TMP_Count
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		
		'Flat graphic X2
		printf("Decompiling  '" + TMP_FileName:String + "' X2 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 28)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T") 
		For TMP_CurrentByte = 1 To 32 * 32
			WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 28) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		
		'Flat graphic X3
		printf("Decompiling  '" + TMP_FileName:String + "' X3 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 32)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T") 
		For TMP_CurrentByte = 1 To 16 * 16
			WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 32) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		
		'Flat graphic X4
		printf("Decompiling  '" + TMP_FileName:String + "' X4 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 36)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T") 
		For TMP_CurrentByte = 1 To 8 * 8
			WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 36) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		
		'Flat graphic X5
		printf("Decompiling  '" + TMP_FileName:String + "' X5 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 40)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T") 
		For TMP_CurrentByte = 1 To 4 * 4
			WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 40) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		
		'Flat graphic X6
		printf("Decompiling  '" + TMP_FileName:String + "' X6 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 44)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T") 
		For TMP_CurrentByte = 1 To 2 * 2
			WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 44) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		
		'Flat graphic X7
		printf("Decompiling  '" + TMP_FileName:String + "' X7 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 48)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T") 
		WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 48) + ImageDataOffset:Int)) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		
		'Flat graphic X8
		printf("Decompiling  '" + TMP_FileName:String + "' X8 flat graphic at offset: " + PeekInt(Rom, TMP_Offset:Int + 52)) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T") 
		WriteByte(TMP_File:TStream, PeekByte(Rom, PeekInt(Rom, TMP_Offset:Int + 52) + ImageDataOffset:Int)) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"	
	EndIf	
	If(TMP_Type:String = "TEXTURE") 
		'Texture header
		printf("Decompiling texture '" + TMP_FileName:String + "' header at offset: " + TMP_Offset:Int) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		For TMP_CurrentByte = 1 To 64 * TMP_Count
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		
		TMP_X1Width:Int = PeekInt(Rom, TMP_Offset:Int + 8) 
		TMP_X1Height:Int = PeekInt(Rom, TMP_Offset:Int + 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		
		'Get all the 2nd offset location files
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		
		'Dump the location file
		'X1
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC") 
		For TMP_CurrentByte = 1 To TMP_X1Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC"
		
		'X2
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC") 
		For TMP_CurrentByte = 1 To TMP_X2Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC"
	
		'X3
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC") 
		For TMP_CurrentByte = 1 To TMP_X3Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC"
		
		'X4
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC") 
		For TMP_CurrentByte = 1 To TMP_X4Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC"
		
		'X5
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC") 
		For TMP_CurrentByte = 1 To TMP_X5Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC"
		
		'X6
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC") 
		For TMP_CurrentByte = 1 To TMP_X6Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC"
	
		'X7
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC") 
		For TMP_CurrentByte = 1 To TMP_X7Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC"
		
		'X8
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC") 
		For TMP_CurrentByte = 1 To TMP_X8Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC"
			
		'FUCKING FINALLY lets decompile the actual graphic
		'X1
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T") 
		'Does 128 integers or god knows how much depending on the texture, really save that much cart space?
		For TMP_CurrentByte = 1 To TMP_X1Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X1Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"
		
		'X2
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T") 
		For TMP_CurrentByte = 1 To TMP_X2Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X2Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		
		'X3
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T") 
		For TMP_CurrentByte = 1 To TMP_X3Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X3Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		
		'X4
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T") 
		For TMP_CurrentByte = 1 To TMP_X4Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X4Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		
		'X5
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T") 
		For TMP_CurrentByte = 1 To TMP_X5Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X5Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		
		'X6
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T") 
		For TMP_CurrentByte = 1 To TMP_X6Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X6Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		
		'X7
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T") 
		For TMP_CurrentByte = 1 To TMP_X7Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X7Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		
		'X8
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T") 
		For TMP_CurrentByte = 1 To TMP_X8Width:Int
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
			'Write vertical line bytes and stop whenever it reaches the end of the height
			For TMP_CurrentVert = 1 To TMP_X8Height:Int
				WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1)) 
			Next
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
	EndIf
	If(TMP_Type:String = "SPRITE") 
		'Sprite header
		printf("Decompiling sprite '" + TMP_FileName:String + "' header at offset: " + TMP_Offset:Int) 
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H") 
		For TMP_CurrentByte = 1 To 64 * TMP_Count
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_Offset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		
		TMP_X1Width:Int = PeekInt(Rom, TMP_Offset:Int + 8) 
		TMP_X1Height:Int = PeekInt(Rom, TMP_Offset:Int + 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		
		'Get all the 2nd offset location files
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		
		'Dump the location file
		'X1
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC") 
		For TMP_CurrentByte = 1 To TMP_X1Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC"
		
		'X2
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC") 
		For TMP_CurrentByte = 1 To TMP_X2Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC"
	
		'X3
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC") 
		For TMP_CurrentByte = 1 To TMP_X3Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC"
		
		'X4
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC") 
		For TMP_CurrentByte = 1 To TMP_X4Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC"
		
		'X5
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC") 
		For TMP_CurrentByte = 1 To TMP_X5Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC"
		
		'X6
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC") 
		For TMP_CurrentByte = 1 To TMP_X6Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC"
	
		'X7
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC") 
		For TMP_CurrentByte = 1 To TMP_X7Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC"
		
		'X8
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC") 
		For TMP_CurrentByte = 1 To TMP_X8Width:Int * 4 'Integers/offsets are 4 bytes long so...
			WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1)) 
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC"
			
		'FUCKING FINALLY lets decompile the actual graphic
		'X1
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T") 
		'Loop however many times depending how wide a sprite is
		For TMP_CurrentByte = 0 To TMP_X1Width:Int - 1
			'Get the offset for the graphics
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 

			'So the Int offset is Nothing? Then it's a fully blank vertical line (Usually the side of sprites)
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X1Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				'Is there an 0A? If not, just directly draw the ni[b][b]a
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)  '0A
					'Loop however many times depending how tall a sprite is
					For TMP_CurrentVertY = 0 To TMP_X1Height:Int - 1
						'Lets start drawing then!
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					'0 is 0A, a null byte for defining whether we need to have START/STOPATY values, so we gotta add 1 which is the startdrawing at Y value, and 2 is to stop drawing at y value if there's a 0A.
					'Anything past 2 (3+) is the actual graphics
					
					'Y pixel to start drawing
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					'Y pixel to STOP drawing, the remaining pixels are transparent
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					'Loop however many times depending how tall a sprite is
					For TMP_CurrentVertY = 0 To TMP_X1Height:Int - 1
						'Is the current Y position at the position to start drawing the sprite?
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							'Finished drawing the vertical pixels?
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								'Then fill the rest with transparent
								WriteByte(TMP_File:TStream, 0) 
							Else
								'Lets start drawing then!
								'1: Get the offset of graphic
								'2: Add 3 as 0, 1 and 2 are for Start/Stop positions
								'3: Add the current vertical pixel we're on
								'4: Take away the transparent pixels we've already done
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							'Draw a transparent pixel
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"

		'X2
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T") 
		For TMP_CurrentByte = 0 To TMP_X2Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X2Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10) 
					For TMP_CurrentVertY = 0 To TMP_X2Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X2Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		
		'X3
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T") 
		For TMP_CurrentByte = 0 To TMP_X3Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X3Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X3Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X3Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		
		'X4
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T") 
		For TMP_CurrentByte = 0 To TMP_X4Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X4Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X4Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X4Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
	
		'X5
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T") 
		For TMP_CurrentByte = 0 To TMP_X5Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X5Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X5Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X5Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		
		'X6
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T") 
		For TMP_CurrentByte = 0 To TMP_X6Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X6Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X6Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X6Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		
		'X7
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T") 
		For TMP_CurrentByte = 0 To TMP_X7Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X7Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X7Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X7Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		
		'X8
		TMP_File:TStream = WriteFile("decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T") 
		For TMP_CurrentByte = 0 To TMP_X8Width:Int - 1
			TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
			If(TMP_CurrentLOC:Int = 0) 
				For TMP_CurrentVertY = 0 To TMP_X8Height:Int - 1
					'0 is transparent
					WriteByte(TMP_File:TStream, 0) 
				Next
			Else
				If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)
					For TMP_CurrentVertY = 0 To TMP_X8Height:Int - 1
						WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY)) 
					Next
				Else
					TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
					TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
					For TMP_CurrentVertY = 0 To TMP_X8Height:Int - 1
						If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
							If(TMP_CurrentVertY >= TMP_StopAtY:Int) 
								WriteByte(TMP_File:TStream, 0) 
							Else
								WriteByte(TMP_File:TStream, PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int)) 
							EndIf
						Else
							WriteByte(TMP_File:TStream, 0) 
						EndIf
					Next
				EndIf
			EndIf
		Next
		CloseFile(TMP_File:TStream) 
		printf "Done writing: decompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
	EndIf
EndFunction

'Decompile program
If Not(Rom) 
	Crash("Missing 'DoomII.gba'.") 
EndIf

'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf
'DecompileFile("bin\PLAYPAL.txt", "decompile\PLAYPAL") 
'WaitKey

Global PercentTimer:Float = MilliSecs() 
Print "Counting Definitions..."
Global BinCount:Float = ScanDir:Float("bin\") 
Print Int(BinCount:Float) + " Definitions!"
Global CurrentLoopCount:Float = 0
Print "Decompiling..."

Repeat
	CurrentLoopCount:Float = CurrentLoopCount:Float + 1
	TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
	If(TMP_CurrentFile:String = "") 
		Exit
	ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
		If(TMP_CurrentFile:String.EndsWith(".TXT")) 
			printf "Loading: " + TMP_CurrentFile:String
			'DecompileFile("bin\" + TMP_CurrentFile:String, "decompile\" + Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
			DecompileFile(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4))
		EndIf
	EndIf
	If(MilliSecs() - PercentTimer:Float > 1000) 
		Print Int(CurrentLoopCount:Float / BinCount:Float * 100) + "% Completed!"
		PercentTimer:Float = MilliSecs() 
	EndIf
Forever

Print "Decompilation complete!"