'---------------------------------------------------------------------------------------------------
' This program was written with BLIde (www.blide.org)
' Application: Decompiler
' Author: Kippykip
' License: do whatever you fucken want
'---------------------------------------------------------------------------------------------------

Framework brl.D3D7Max2D
Import BRL.Bank
Import BRL.System
Import BRL.Timer
Import BRL.Retro
Import brl.PNGLoader
Include "GBAGFX.bmx"

Global Rom = LoadBank("DoomII.gba") 
Global ImageDataOffset:Int = 3316928 'Always gotta add this when decompiling sprites/textures/flats for some reason
Print "Doom II GBA - Modding Tools - http://kippykip.com"

Global ScaleMode:String = "CENTER" 'V1.1, Modes are: Cookie, Topmost, Center, Bottommost
If(AppArgs.length > 1) 
	ScaleMode:String = Upper:String(AppArgs[1] ) 
	If(ScaleMode:String <> "COOKIE" And ScaleMode:String <> "CENTER" And ScaleMode:String <> "TOPMOST" And ScaleMode:String <> "BOTTOMMOST") 
		ScaleMode:String = "CENTER"
	EndIf
EndIf
Function printf(TMP_TXT:String = "") 
	'If you really want to re-enable the detailed stuff ;)
	'Print TMP_TXT:String
End Function


Function Crash(TMP_ErrString:String = "Unknown Error") 
	Print("Error: " + TMP_ErrString) 
	'While Not(AppTerminate()) 
	'Wend
	End
End Function

'Decompile program
If Not(Rom) 
	Crash("Missing 'DoomII.gba'.") 
EndIf
'This section of code was where I was trying to work out what was corrupting the ammo graphic.
'It was then when I found out that if there's an 0A, it doesn't use YSTART and YEND vars.
Global EnableDevWarning = False
Function DevWarning(TMP_TroublingOffset:Int, TMP_FN:String) 
	If(EnableDevWarning) 
		If(Left:String(TMP_FN:String, 6) <> "AMMOA0") 
			If(TMP_TroublingOffset:Int < 999 + ImageDataOffset:Int) 
				Print "POSSIBLE AMMO SPRITE FUCKUP TRYNA MODIFY OFFSET: " + TMP_TroublingOffset:Int + "(" + (TMP_TroublingOffset:Int - ImageDataOffset:Int) + ")"
				Print "CUNT FILE CAUSING THIS: " + TMP_FN:String
				Delay(5000) 
				
			EndIf
		EndIf
	EndIf
EndFunction

Function RecompileFile(TMP_FileName:String) 
	TMP_CurrentTXT:TStream = ReadStream("bin\" + TMP_FileName:String + ".txt") 
	TMP_Type:String = ""
	TMP_Width:Int = 0
	TMP_Height:Int = 0
	TMP_Count:Int = 0
	TMP_Offset:Int = 0
	
	While Not Eof(TMP_CurrentTXT) 
		TMP_CurrentLine:String = Upper(ReadLine(TMP_CurrentTXT)) 
		If(TMP_CurrentLine:String.Contains("TYPE:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("TYPE:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Type:String = TMP_CurrentLine:String
		EndIf
		If(TMP_CurrentLine:String.Contains("WIDTH:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("WIDTH:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Width:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("HEIGHT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("HEIGHT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Height:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("COUNT:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("COUNT:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Count:Int = TMP_CurrentLine:String.ToInt() 
		EndIf
		If(TMP_CurrentLine:String.Contains("OFFSET:")) 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace("OFFSET:", "") 
			TMP_CurrentLine:String = TMP_CurrentLine:String.Replace(" ", "") 
			TMP_Offset:Int = TMP_CurrentLine:String.ToInt() 
		EndIf	
	Wend
	If(TMP_Type:String = "PALETTE") 
		'loop how many palettes etc
		For TMP_CurrentPalette = 1 To TMP_Count
			TMP_FileURL:String = "recompile\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentPalette + ".D2P"
			If(TMP_Count = 1) 
				TMP_FileURL:String = "recompile\PALETTE\" + TMP_FileName:String + ".D2P"
			EndIf
			If(FileType(TMP_FileURL:String) = 1) 
				TMP_File:TBank = LoadBank(TMP_FileURL:String) 
				'There are 256 colours in each palette
				For TMP_CurrentByte = 1 To 256 * 3 'RGB is 3
					PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 3 * 256), PeekByte(TMP_File, TMP_CurrentByte - 1)) 
					'PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 3 * 256), 0) 
				Next
				Printf("Recompiling: " + TMP_FileURL:String) 
			Else
				Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
			EndIf
		Next
	EndIf
	If(TMP_Type:String = "555PALETTE") 
		'loop how many palettes etc
		For TMP_CurrentPalette = 1 To TMP_Count
			TMP_FileURL:String = "recompile\PALETTE\" + TMP_FileName:String + "." + TMP_CurrentPalette + ".D2P"
			If(TMP_Count = 1) 
				TMP_FileURL:String = "recompile\PALETTE\" + TMP_FileName:String + ".D2P"
			EndIf
			If(FileType(TMP_FileURL:String) = 1) 
				TMP_File:TBank = LoadBank(TMP_FileURL:String) 
				'There are 256 colours in each palette
				For TMP_CurrentByte = 1 To 256
					'PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 3 * 256), 0) 
					'PeekShort(Rom, (TMP_CurrentByte - 1) * 2 + TMP_Offset:Int + (TMP_CurrentPalette - 1)) 
					PokeShort(Rom, (TMP_CurrentByte - 1) * 2 + TMP_Offset:Int + ((TMP_CurrentPalette - 1) * 2 * 256), GFX.Convert8888to555(PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * 3), PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * 3 + 1), PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * 3 + 2))) 
				Next
				Printf("Recompiling: " + TMP_FileURL:String) 
			Else
				Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
			EndIf
		Next
	EndIf
	If(TMP_Type:String = "BLANKMEM") 
		TMP_FileURL:String = "recompile\" + TMP_FileName:String + ".D2M"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_Count
				PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	EndIf
	If(TMP_Type:String = "SOUND") 
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".RAW"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_Count
				If(TMP_CurrentByte > BankSize(TMP_File:TBank)) 
					PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, 0) 
				Else
					PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	EndIf
	If(TMP_Type:String = "IMAGE" Or TMP_Type:String = "TIMAGE") 
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".D2I"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_Width * TMP_Height
				PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			'	PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, 0) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	EndIf
	If(TMP_Type:String = "FLAT") 
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 64
				PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X2
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 32 * 32
				PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 28) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X3
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 16 * 16
				PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 32) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X4
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 8 * 8
				PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 36) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X5
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 4 * 4
				PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 40) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X6
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 2 * 2
				PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 44) + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X7
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 48) + ImageDataOffset:Int, PeekByte(TMP_File, 0)) 
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X8
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			PokeByte(Rom, PeekInt(Rom, TMP_Offset:Int + 52) + ImageDataOffset:Int, PeekByte(TMP_File, 0)) 
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	EndIf
	If(TMP_Type:String = "TEXTURE") 
		'Header
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 64 * TMP_Count
				PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'Get all the image definitons
		TMP_X1Width:Int = PeekInt(Rom, TMP_Offset:Int + 8) 
		TMP_X1Height:Int = PeekInt(Rom, TMP_Offset:Int + 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		
		'Get all the 2nd offset location files
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		
		'X1 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X1Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	
		'X2 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X2Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X3 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X3Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X4 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X4Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X5 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X5Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	
		'X6 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X6Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X7 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X7Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X8 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X8Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'Get all the 2nd offset location files AGAIN (Incase they changed.)
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		
		'X1 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X1Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X1Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X1Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X1Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X1Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X1Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X1Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X1Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X1Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X1Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X2 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X2Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X2Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X2Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X2Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X2Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X2Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X2Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X2Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X2Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X2Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X3 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X3Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X3Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X3Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X3Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X3Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X3Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X3Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X3Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X3Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X3Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X4 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X4Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X4Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X4Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X4Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X4Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X4Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X4Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X4Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X4Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X4Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X5 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X5Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X5Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X5Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X5Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X5Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X5Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X5Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X5Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X5Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X5Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X6 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X6Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X6Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X6Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X6Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X6Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X6Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X6Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X6Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X6Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X6Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X7 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X7Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X7Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X7Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X7Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X7Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X7Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X7Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X7Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X7Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X7Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf

		'X8 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X8Width:Int
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + ((TMP_CurrentByte:Int - 1) * 4)) 
				'Write vertical line bytes and stop whenever it reaches the end of the height
				For TMP_CurrentVert = 1 To TMP_X8Height:Int
					'Spent ages working out the formula for this one line for whatever reason
					PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X8Height:Int + TMP_CurrentVert - 1)) 
				Next
				'Textures have 8 duplicated lines starting from the top.
				'Why? I don't fucking know, but they flicker if you don't replace this part
				TMP_StartVert = 0
				For TMP_CurrentVert = 1 To 8
					If(TMP_X8Height:Int < 8) 
						TMP_SizeDiff = 8 - TMP_X8Height:Int
						TMP_StartVert = TMP_StartVert + 1
						If(TMP_StartVert > TMP_X8Height:Int) 
							TMP_StartVert = 1
						EndIf
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X8Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X8Height:Int + TMP_StartVert - 1)) 
					Else
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_X8Height:Int + TMP_CurrentVert - 1, PeekByte(TMP_File:TBank, (TMP_CurrentByte - 1) * TMP_X8Height:Int + TMP_CurrentVert - 1)) 
					EndIf
				Next
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	EndIf
	If(TMP_Type:String = "SPRITE") 
		'Header
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".H"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To 64 * TMP_Count
				PokeByte(Rom, TMP_CurrentByte - 1 + TMP_Offset:Int, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'Get all the image definitons
		TMP_X1Width:Int = PeekInt(Rom, TMP_Offset:Int + 8) 
		TMP_X1Height:Int = PeekInt(Rom, TMP_Offset:Int + 4) 
		If(TMP_X1Width:Int < 1) 
			TMP_X1Width:Int = 1
		EndIf
		If(TMP_X1Height:Int < 1) 
			TMP_X1Height:Int = 1
		EndIf
		TMP_X2Width:Int = TMP_X1Width:Int / 2
		TMP_X2Height:Int = TMP_X1Height:Int / 2
		If(TMP_X2Width:Int < 1) 
			TMP_X2Width:Int = 1
		EndIf
		If(TMP_X2Height:Int < 1) 
			TMP_X2Height:Int = 1
		EndIf
		TMP_X3Width:Int = TMP_X2Width:Int / 2
		TMP_X3Height:Int = TMP_X2Height:Int / 2
		If(TMP_X3Width:Int < 1) 
			TMP_X3Width:Int = 1
		EndIf
		If(TMP_X3Height:Int < 1) 
			TMP_X3Height:Int = 1
		EndIf
		TMP_X4Width:Int = TMP_X3Width:Int / 2
		TMP_X4Height:Int = TMP_X3Height:Int / 2
		If(TMP_X4Width:Int < 1) 
			TMP_X4Width:Int = 1
		EndIf
		If(TMP_X4Height:Int < 1) 
			TMP_X4Height:Int = 1
		EndIf
		TMP_X5Width:Int = TMP_X4Width:Int / 2
		TMP_X5Height:Int = TMP_X4Height:Int / 2
		If(TMP_X5Width:Int < 1) 
			TMP_X5Width:Int = 1
		EndIf
		If(TMP_X5Height:Int < 1) 
			TMP_X5Height:Int = 1
		EndIf
		TMP_X6Width:Int = TMP_X5Width:Int / 2
		TMP_X6Height:Int = TMP_X5Height:Int / 2
		If(TMP_X6Width:Int < 1) 
			TMP_X6Width:Int = 1
		EndIf
		If(TMP_X6Height:Int < 1) 
			TMP_X6Height:Int = 1
		EndIf
		TMP_X7Width:Int = TMP_X6Width:Int / 2
		TMP_X7Height:Int = TMP_X6Height:Int / 2
		If(TMP_X7Width:Int < 1) 
			TMP_X7Width:Int = 1
		EndIf
		If(TMP_X7Height:Int < 1) 
			TMP_X7Height:Int = 1
		EndIf
		TMP_X8Width:Int = TMP_X7Width:Int / 2
		TMP_X8Height:Int = TMP_X7Height:Int / 2
		If(TMP_X8Width:Int < 1) 
			TMP_X8Width:Int = 1
		EndIf
		If(TMP_X8Height:Int < 1) 
			TMP_X8Height:Int = 1
		EndIf
		
		'Get all the 2nd offset location files
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		
		'X1 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X1Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	
		'X2 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X2Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X3 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X3Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X4 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X4Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X5 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X5Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
	
		'X6 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X6Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X7 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X7Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X8 LOC
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.LOC"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 1 To TMP_X8Width:Int * 4 'Integers/offsets are 4 bytes long so...
				PokeByte(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + TMP_CurrentByte:Int - 1, PeekByte(TMP_File, TMP_CurrentByte - 1)) 
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		rem
		'Get all the 2nd offset location files AGAIN (Incase they changed.)
		TMP_X1LOC:Int = PeekInt(Rom, TMP_Offset:Int + 24) 
		TMP_X2LOC:Int = PeekInt(Rom, TMP_Offset:Int + 28) 
		TMP_X3LOC:Int = PeekInt(Rom, TMP_Offset:Int + 32) 
		TMP_X4LOC:Int = PeekInt(Rom, TMP_Offset:Int + 36) 
		TMP_X5LOC:Int = PeekInt(Rom, TMP_Offset:Int + 40) 
		TMP_X6LOC:Int = PeekInt(Rom, TMP_Offset:Int + 44) 
		TMP_X7LOC:Int = PeekInt(Rom, TMP_Offset:Int + 48) 
		TMP_X8LOC:Int = PeekInt(Rom, TMP_Offset:Int + 52) 
		EndRem
		For TMP_XCounter = 1 To 8
			TMP_XWidth:Int = PeekInt(Rom, TMP_Offset:Int + 8) 
			TMP_XHeight:Int = PeekInt(Rom, TMP_Offset:Int + 4) 
			If(TMP_XCounter = 2) 
				TMP_XWidth:Int = TMP_XWidth:Int / 2
				TMP_XHeight:Int = TMP_XHeight:Int / 2
			ElseIf(TMP_XCounter = 3) 
				TMP_XWidth:Int = TMP_XWidth:Int / 4
				TMP_XHeight:Int = TMP_XHeight:Int / 4
			ElseIf(TMP_XCounter = 4) 
				TMP_XWidth:Int = TMP_XWidth:Int / 8
				TMP_XHeight:Int = TMP_XHeight:Int / 8
			ElseIf(TMP_XCounter = 5) 
				TMP_XWidth:Int = TMP_XWidth:Int / 16
				TMP_XHeight:Int = TMP_XHeight:Int / 16
			ElseIf(TMP_XCounter = 6) 
				TMP_XWidth:Int = TMP_XWidth:Int / 32
				TMP_XHeight:Int = TMP_XHeight:Int / 32
			ElseIf(TMP_XCounter = 7) 
				TMP_XWidth:Int = TMP_XWidth:Int / 64
				TMP_XHeight:Int = TMP_XHeight:Int / 64
			ElseIf(TMP_XCounter = 8) 
				TMP_XWidth:Int = TMP_XWidth:Int / 128
				TMP_XHeight:Int = TMP_XHeight:Int / 128
			endif
			If(TMP_XWidth:Int < 1) 
				TMP_XWidth:Int = 1
			EndIf
			If(TMP_XHeight:Int < 1) 
				TMP_XHeight:Int = 1
			EndIf
			TMP_XLOC:Int = PeekInt(Rom, TMP_Offset:Int + 20 + (TMP_XCounter * 4)) 

			'X DATA
			TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X" + TMP_XCounter + ".D2T"
			If(FileType(TMP_FileURL:String) = 1) 
				TMP_File:TBank = LoadBank(TMP_FileURL:String) 
				'Loop however many times depending how wide a sprite is
				For TMP_CurrentByte = 0 To TMP_XWidth:Int - 1
					'Get the offset for the graphics
					TMP_CurrentLOC:Int = PeekInt(Rom, TMP_XLOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
					If(TMP_CurrentLOC:Int > BankSize(Rom)) 
						Crash("HALT!!! OUT OF BOUNDS!") 
					EndIf
					'So the Int offset is Nothing? Then it's a fully blank vertical line (Usually the side of sprites)
					If(TMP_CurrentLOC:Int <> 0) 
						If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)   '0A marker
							'Loop however many times depending how tall a sprite is
							For TMP_CurrentVertY = 0 To TMP_XHeight:Int - 1
								TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_XHeight:Int + TMP_CurrentVertY) 
								If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
									TMP_0APrevention:Byte = 11
								EndIf
								PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
							Next
						Else
							'Y pixel to start drawing
							TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
							'Y pixel to STOP drawing, the remaining pixels are transparent
							TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
							
							'Y Adjusting code for V1.1
							TMP_SSDifference:Int = TMP_StopAtY:Int - TMP_StartAtY:Int
							TMP_NewStartAtY:Int = TMP_StartAtY:Int
							TMP_NewStartAtY:Int = TMP_StopAtY:Int
							TMP_RoundingStopAtY:Int = 0
							For TMP_CurrentVertStartY = 0 To TMP_XHeight:Int - 1
								If(PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_XHeight:Int + TMP_CurrentVertStartY) <> 0) 
									TMP_NewStartAtY:Int = TMP_CurrentVertStartY
									Exit
								EndIf
							Next
							For TMP_CurrentVertStopY = 0 To TMP_XHeight:Int - 1
								If(PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_XHeight:Int + TMP_CurrentVertStopY) <> 0) 
									TMP_RoundingStopAtY:Int = TMP_CurrentVertStopY + 1
								'	Exit
								EndIf
							Next
							TMP_SSRoundDifference:Int = TMP_RoundingStopAtY:Int - TMP_NewStartAtY:Int
							'Print TMP_SSRoundDifference:Int
							'Print TMP_SSDifference:Int
							If(ScaleMode = Upper:String("CENTER")) 
								If(TMP_SSRoundDifference:Int > TMP_SSDifference:Int And TMP_SSDifference:Int > 0 And TMP_SSRoundDifference:Int > 0) 
									TMP_NewStartAtY:Int = TMP_NewStartAtY:Int + (TMP_SSRoundDifference:Int / 2) - (TMP_SSDifference:Int / 2) 
								EndIf
							ElseIf(ScaleMode = Upper:String("BOTTOMMOST")) 
								TMP_NewStartAtY:Int = TMP_RoundingStopAtY:Int - TMP_SSDifference:Int
							EndIf
							'Delay 500
							
							TMP_NewStopAtY:Int = TMP_NewStartAtY:Int + TMP_SSDifference:Int
							If(ScaleMode <> Upper:String("COOKIE")) 
								'Write new values
								PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_NewStartAtY:Int) 
								'Y pixel to STOP drawing, the remaining pixels are transparent
								PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2, TMP_NewStopAtY:Int) 
								TMP_StartAtY:Int = TMP_NewStartAtY:Int
								TMP_StopAtY:Int = TMP_NewStopAtY:Int
							EndIf
							'End of V1.1 Code
							
							'Loop however many times depending how tall a sprite is
							For TMP_CurrentVertY = 0 To TMP_XHeight:Int - 1
								'Is the current Y position at the position to start drawing the sprite?
								If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
									'Finished drawing the vertical pixels?
									If(TMP_CurrentVertY < TMP_StopAtY:Int) 
										PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_XHeight:Int + TMP_CurrentVertY)) 
										DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X.D2T") 
									EndIf
								EndIf
							Next
						EndIf
					EndIf
				Next
				Printf("Recompiling: " + TMP_FileURL:String) 
			Else
				Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
			EndIf
		Next
		
		'X1 DATA
		rem
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X1.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			'Loop however many times depending how wide a sprite is
			For TMP_CurrentByte = 0 To TMP_X1Width:Int - 1
				'Get the offset for the graphics
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X1LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				'So the Int offset is Nothing? Then it's a fully blank vertical line (Usually the side of sprites)
				If(TMP_CurrentLOC:Int <> 0) 
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)   '0A marker
						'Loop however many times depending how tall a sprite is
						For TMP_CurrentVertY = 0 To TMP_X1Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X1Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						'Y pixel to start drawing
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						'Y pixel to STOP drawing, the remaining pixels are transparent
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						
						'Y Adjusting code for V1.1
						TMP_SSDifference:Int = TMP_StopAtY:Int - TMP_StartAtY:Int
						TMP_NewStartAtY:Int = TMP_StartAtY:Int
						TMP_NewStartAtY:Int = TMP_StopAtY:Int
						TMP_RoundingStopAtY:Int = 0
						For TMP_CurrentVertStartY = 0 To TMP_X1Height:Int - 1
							If(PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X1Height:Int + TMP_CurrentVertStartY) <> 0) 
								TMP_NewStartAtY:Int = TMP_CurrentVertStartY
								Exit
							EndIf
						Next
						For TMP_CurrentVertStopY = 0 To TMP_X1Height:Int - 1
							If(PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X1Height:Int + TMP_X1Height:Int - TMP_CurrentVertStopY) <> 0) 
								TMP_RoundingStopAtY:Int = TMP_X1Height:Int - TMP_CurrentVertStopY + 1
								Exit
							EndIf
						Next
						TMP_SSRoundDifference:Int = TMP_RoundingStopAtY:Int - TMP_NewStartAtY:Int
						'Print TMP_SSRoundDifference:Int
						'Print TMP_SSDifference:Int
						If(TMP_SSRoundDifference:Int > TMP_SSDifference:Int And TMP_SSDifference:Int > 0 And TMP_SSRoundDifference:Int > 0) 
							TMP_NewStartAtY:Int = TMP_NewStartAtY:Int + (TMP_SSRoundDifference:Int / 2) - (TMP_SSDifference:Int / 2) 
						EndIf
						'Delay 500
						
						TMP_NewStopAtY:Int = TMP_NewStartAtY:Int + TMP_SSDifference:Int
						'Write new values
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_NewStartAtY:Int) 
						'Y pixel to STOP drawing, the remaining pixels are transparent
						PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2, TMP_NewStopAtY:Int) 
						TMP_StartAtY:Int = TMP_NewStartAtY:Int
						TMP_StopAtY:Int = TMP_NewStopAtY:Int
						'End of V1.1 Code
						
						'Loop however many times depending how tall a sprite is
						For TMP_CurrentVertY = 0 To TMP_X1Height:Int - 1
							'Is the current Y position at the position to start drawing the sprite?
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								'Finished drawing the vertical pixels?
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X1Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X1.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X2 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X2.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X2Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X2LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X2Width:Int * TMP_X2Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X2.D2T") 
				'	ElseIf(TMP_X2Height:Int = 2) ' And TMP_X2Width:Int <= 2)    'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X2.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X2.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)  '0A marker
						For TMP_CurrentVertY = 0 To TMP_X2Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X2Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X2Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X2Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X2.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X3 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X3.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X3Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X3LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X3Width:Int * TMP_X3Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X3.D2T") 
				'	ElseIf(TMP_X3Height:Int = 2) ' And TMP_X3Width:Int <= 2)     'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X3.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X3.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)   '0A marker
						For TMP_CurrentVertY = 0 To TMP_X3Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X3Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X3Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X3Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X3.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X4 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X4.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X4Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X4LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X4Width:Int * TMP_X4Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X4.D2T") 
				'	ElseIf(TMP_X4Height:Int = 2) ' And TMP_X4Width:Int <= 2)    'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X4.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X4.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)    '0A marker
						For TMP_CurrentVertY = 0 To TMP_X4Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X4Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X4Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X4Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X4.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X5 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X5.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X5Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X5LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X5Width:Int * TMP_X5Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X5.D2T") 
				'	ElseIf(TMP_X5Height:Int = 2) ' And TMP_X5Width:Int <= 2)    'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X5.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X5.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)      '0A marker
						For TMP_CurrentVertY = 0 To TMP_X5Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X5Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X5Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X5Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X5.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X6 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X6.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X6Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X6LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X6Width:Int * TMP_X6Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X6.D2T") 
				'	ElseIf(TMP_X6Height:Int = 2) ' And TMP_X6Width:Int <= 2)      'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X6.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X6.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)       '0A marker
						For TMP_CurrentVertY = 0 To TMP_X6Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X6Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X6Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X6Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X6.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X7 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X7.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			Printf("Recompiling: " + TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X7Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X7LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X7Width:Int * TMP_X7Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		Printf TMP_CurrentLOC:Int
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X7.D2T") 
				'	ElseIf(TMP_X7Height:Int = 2) ' And TMP_X7Width:Int <= 2)     'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X7.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X7.D2T") 
				'	Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)      '0A marker
						For TMP_CurrentVertY = 0 To TMP_X7Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X7Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X7Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X7Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X7.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		
		'X8 DATA
		TMP_FileURL:String = "recompile\" + TMP_Type:String + "\" + TMP_FileName:String + ".X8.D2T"
		If(FileType(TMP_FileURL:String) = 1) 
			TMP_File:TBank = LoadBank(TMP_FileURL:String) 
			For TMP_CurrentByte = 0 To TMP_X8Width:Int - 1
				TMP_CurrentLOC:Int = PeekInt(Rom, TMP_X8LOC:Int + ImageDataOffset:Int + (TMP_CurrentByte:Int * 4)) 
				If(TMP_CurrentLOC:Int <> 0) 
				'	If(TMP_X8Width:Int * TMP_X8Height:Int = 1) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, 0)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X8.D2T") 
				'	ElseIf(TMP_X8Height:Int = 2)   ' And TMP_X8Width:Int <= 2)    'And TMP_CurrentByte = 0) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + TMP_CurrentByte)) 
				'		PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, PeekByte(TMP_File:TBank, TMP_CurrentByte * 1 + 1 + TMP_CurrentByte)) 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int, TMP_FileName:String + ".X8.D2T") 
				'		DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 1, TMP_FileName:String + ".X8.D2T") 
					'Else
					If(PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int) <> 10)        '0A marker
						For TMP_CurrentVertY = 0 To TMP_X8Height:Int - 1
							TMP_0APrevention:Byte = PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X8Height:Int + TMP_CurrentVertY) 
							If(TMP_0APrevention:Byte = 10 And TMP_CurrentVertY = 0) 
								TMP_0APrevention:Byte = 11
							EndIf
							PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + TMP_CurrentVertY, TMP_0APrevention:Byte) 
						Next
					Else
						TMP_StartAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 1) 
						TMP_StopAtY:Int = PeekByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 2) 
						For TMP_CurrentVertY = 0 To TMP_X8Height:Int - 1
							If(TMP_CurrentVertY >= TMP_StartAtY:Int) 
								If(TMP_CurrentVertY < TMP_StopAtY:Int) 
									PokeByte(Rom, TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, PeekByte(TMP_File:TBank, (TMP_CurrentByte) * TMP_X8Height:Int + TMP_CurrentVertY)) 
									DevWarning(TMP_CurrentLOC:Int + ImageDataOffset:Int + 3 + TMP_CurrentVertY - TMP_StartAtY:Int, TMP_FileName:String + ".X8.D2T") 
								EndIf
							EndIf
						Next
					EndIf
				EndIf
			Next
			Printf("Recompiling: " + TMP_FileURL:String) 
		Else
			Printf("Missing: '" + TMP_FileURL:String + "'. Ignoring.") 
		EndIf
		endrem
	EndIf
EndFunction
'Open directory
Global Directory_Bin:Int = ReadDir("bin\") 
If Not(Directory_Bin) 
	Crash("Missing 'bin' directory.") 
EndIf
Global PercentTimer:Float = MilliSecs() 
Print "Counting Definitions..."
Global BinCount:Float = ScanDir:Float("bin\") 
Print Int(BinCount:Float) + " Definitions!"
Global CurrentLoopCount:Float = 0
Print "Using VPOS scalemode: " + ScaleMode:String
Print "Recompiling..."
Repeat
	CurrentLoopCount:Float = CurrentLoopCount:Float + 1
	TMP_CurrentFile:String = Upper(NextFile(Directory_Bin)) 
	If(TMP_CurrentFile:String = "") 
		Exit
	ElseIf Not(TMP_CurrentFile:String = "." Or TMP_CurrentFile:String = "..") 
		If(TMP_CurrentFile:String.EndsWith(".TXT")) 
			RecompileFile(Left(TMP_CurrentFile:String, TMP_CurrentFile:String.Length - 4)) 
		EndIf
	EndIf
	If(MilliSecs() - PercentTimer:Float > 1000) 
		Print Int(CurrentLoopCount:Float / BinCount:Float * 100) + "% Completed!"
		PercentTimer:Float = MilliSecs() 
	EndIf
Forever
SaveBank(Rom, "DoomII_Recomp.gba") 
Print "Successfully exported 'DoomII_Recomp.gba'!"